package com.ecnu.platform.service

import com.three.common.vo.SelectOption
import com.three.data_api.dm.annos.BizApiMethod
import com.three.data_api.dm.annos.Doc4MethodPara
import com.three.data_api.dm.annos.Doc4MethodRes
import com.three.data_api.dm.constants.ThreeConstant
import com.three.data_api.dm.entity.AuqResult
import com.three.data_api.service.impl.BaseEntityServiceImpl

class AlgDefinitionService extends BaseEntityServiceImpl {

    public static final String EN_AlgDefinition = "AlgDefinition"
    public static final String EN_AlgDefinitionVo = "AlgDefinitionVo"

    @Override
    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "查询实体ID")
    String getEntityId(Map<String, Object> map) {
        return EN_AlgDefinition;
    }

    @Override
    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "查询算法定义")
    @Doc4MethodRes(key = "result", desc = "算法定义", refClassName = EN_AlgDefinition)
    AuqResult query(Map<String, Object> map) throws Exception {
        return super.query(map)
    }

    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "查询所有算法定义")
    @Doc4MethodRes(key = "result", desc = "算法定义", refClassName = EN_AlgDefinitionVo)
    AuqResult queryAll(Map<String, Object> map) throws Exception {
        return daoService.findAuq(EN_AlgDefinitionVo, map)
    }

    @Override
    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "查询算法定义下拉框")
    List<SelectOption> getSelectOptions(Map<String, Object> map) throws Exception {
        return super.getSelectOptions(map)
    }

    @Override
    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "新增算法定义")
    @Doc4MethodPara(key = "body", desc = "算法定义", refClassName = EN_AlgDefinition)
    void create(Map<String, Object> map) throws Exception {
        super.create(map)
    }

    @Override
    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "修改算法定义")
    @Doc4MethodPara(key = "body", desc = "算法定义", refClassName = EN_AlgDefinition)
    void update(Map<String, Object> map) throws Exception {
        super.update(map)
    }

    @Override
    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "删除算法定义")
    @Doc4MethodPara(key = "body.gkey", desc = "算法定义主键")
    void delete(Map<String, Object> map) throws Exception {
        super.delete(map)
    }

    @Override
    @BizApiMethod(matchedApis = ThreeConstant.BIZ_API_NAME, desc = "恢复算法定义")
    @Doc4MethodPara(key = "body.gkey", desc = "算法定义主键")
    void recover(Map<String, Object> map) throws Exception {
        super.recover(map)
    }
}
